package de.hft.stuttgart.citydoctor2.healing.math;

import java.util.ArrayList;
import java.util.List;

import de.hft.stuttgart.citydoctor2.datastructure.Edge;

public class EdgeNode {

	private Edge e;
	private boolean visited = false;
	public boolean finished = false;
	private List<EdgeNode> children = new ArrayList<>();

	public EdgeNode(Edge e) {
		this.e = e;
	}

	public void resetVisit() {
		visited = false;
	}

	public Edge getEdge() {
		return e;
	}

	public void addChild(EdgeNode childNode) {
		children.add(childNode);
	}

	public List<EdgeNode> getChildren() {
		return children;
	}

	public boolean collectConnectedEdges(List<Edge> edges, EdgeNode parent) {
		if (finished) {
			return false;
		}
		if (visited) {
			createCycle(edges);
			return true;
		}
		visited = true;
		edges.add(e);
		for (EdgeNode n : children) {
			if (n != parent && n.collectConnectedEdges(edges, this)) {
				// found cycle
				return true;
			}
		}
		edges.remove(edges.size() - 1);
		finished = true;
		return false;
	}

	private void createCycle(List<Edge> edges) {
		for (int i = 0; i < edges.size(); i++) {
			Edge compare = edges.get(i);
			if (compare == e) {
				for (int j = 0; j < i; j++) {
					edges.remove(0);
				}
			}
		}
	}
}
